<?php

namespace Unific\Connector\Plugin;

class AbstractPlugin
{
    protected $queueHelper;
    protected $scopeConfig;
    protected $hmacHelper;

    protected $productMetadata;
    protected $moduleList;

    /**
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     * @param \Unific\Connector\Helper\Hmac $hmacHelper
     * @param \Unific\Connector\Helper\Message\Queue $queueHelper
     * @param \Magento\Framework\App\ProductMetadataInterface $productMetadata
     * @param \Magento\Framework\Module\ModuleListInterface $moduleList
     */
    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Unific\Connector\Helper\Hmac $hmacHelper,
        \Unific\Connector\Helper\Message\Queue $queueHelper,
        \Magento\Framework\App\ProductMetadataInterface $productMetadata,
        \Magento\Framework\Module\ModuleListInterface $moduleList
    ) {
        $this->scopeConfig = $scopeConfig;
        $this->queueHelper = $queueHelper;
        $this->hmacHelper = $hmacHelper;

        $this->productMetadata = $productMetadata;
        $this->moduleList = $moduleList;
    }

    public function processWebhook($data, $webhookEndpoint = '', $priority = 5, $subject = 'checkout/create')
    {
        if (filter_var($webhookEndpoint, FILTER_VALIDATE_URL) !== false) {
            $headers = [];
            $headers['X-SUBJECT'] = $subject;

            return $this->queueHelper->queue($webhookEndpoint, $data, $priority, $headers);
        }
    }
}
