<?php

namespace Unific\Connector\Plugin;

use Unific\Connector\Helper\Settings;

class InvoicePlugin extends AbstractPlugin
{
    protected $orderDataHelper;
    protected $customerSession;

    /**
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     * @param \Unific\Connector\Helper\Hmac $hmacHelper
     * @param \Unific\Connector\Helper\Message\Queue $queueHelper
     * @param \Magento\Framework\App\ProductMetadataInterface $productMetadata
     * @param \Magento\Framework\Module\ModuleListInterface $moduleList
     * @param \Unific\Connector\Helper\Data\Order $orderDataHelper
     * @param \Magento\Customer\Model\Session $customerSession
     */
    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Unific\Connector\Helper\Hmac $hmacHelper,
        \Unific\Connector\Helper\Message\Queue $queueHelper,
        \Magento\Framework\App\ProductMetadataInterface $productMetadata,
        \Magento\Framework\Module\ModuleListInterface $moduleList,
        \Unific\Connector\Helper\Data\Order $orderDataHelper,
        \Magento\Customer\Model\Session $customerSession
    ) {
        parent::__construct(
            $scopeConfig,
            $hmacHelper,
            $queueHelper,
            $productMetadata,
            $moduleList
        );

        $this->orderDataHelper = $orderDataHelper;
        $this->customerSession = $customerSession;
    }

    /**
     * @param $subject
     * @return mixed
     */
    public function afterPay($subject)
    {
        if ($this->scopeConfig->getValue('unific/connector/enabled') == 1) {
            $this->orderDataHelper->setOrder($subject->getOrder());
            $this->processWebhook(
                $this->orderDataHelper->getOrderInfo(),
                $this->scopeConfig->getValue('unific/webhook/order_endpoint'),
                Settings::PRIORITY_ORDER,
                'order/invoice'
            );
        }

        return $subject;
    }
}
